// ------------------------------------------------------------------  //
// ft_parInt_IR                                       bach 14.09.2014
//
// Testen Schieberegister Ausgang (4094)  mit IR Fernbedienung
//                                                       getestet OK!
// ------------------------------------------------------------------  //
#include <ft_parInt.h>
#zero_ram

// ** Variable fuer IR Fernbedienung **
int32 lCode=0;
#byte IRAdr = lCode+2       // adress low byte => bit 16-23
#bit db = lCode.0
int16 cnt;
byte l, IRCode;
bit new_IRCode=false;

// ------------------------------------------------------------------  //
void main() {
   setup_adc( no_analogs);
   delay_ms (20);

   input(PIN_A0);                            // umschalten Eingang 
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);   // IR Timer
   enable_interrupts(INT_EXT_H2L);
   enable_interrupts(GLOBAL);

   while (true) {
     output_high(Clk); delay_ms(10);
     output_low(Clk); delay_ms(100);
 
     if (new_IRCode) {
        if (IRCode==0xbf) { Motor(m1,0); Motor(m2,0); }  // halt,   On/Off
        if (IRCode==0xf7) { Motor(m1,0); Motor(m2,0); }  // halt,   Mode
        if (IRCode==0x8f) { Motor(m1,1); Motor(m2,2);    // rechts, Cur. rechts
                            delay_ms(500);
                            Motor(m1,0); Motor(m2,0); }
        if (IRCode==0x4f) { Motor(m1,2); Motor(m2,1);    // links,  Cur. links
                            delay_ms(500);
                            Motor(m1,0); Motor(m2,0); }
        if (IRCode==0x2f) { Motor(m1,1); Motor(m2,1); }  // vor,    Cur. oben
        if (IRCode==0xcf) { Motor(m1,2); Motor(m2,2); }  // zurck, Cur. unten
        new_IRCode=false;
        }
   }
}

// ------------------------------------------------------------------  //
//    IR Fernbedienung   -- BENQ Beamer --   Code (hex)                //
// ------------------------------------------------------------------- //
//    ||/>           3f      On/Off        bf                          //
//    Source         df      Blank         1f     Menu          0f     //
//    Cur. oben      2f      Cur. unten    cf     Timer On      5b     //
//    Cur. rechts    8f      Cur. links    4f     Timer SetUp   9b     //
//    Page Up        5f      Page Down     9f     Enter/Mode    f7     //
//    Zoom +         e7      Zoom -        67     Auto          ef     //
//    Volume +       be      Volume -      3e                          //
// ------------------------------------------------------------------  //
//     Interruptroutine fr den IR Empfnger (TSOP1838, SFH5110 o.)   //
// ------------------------------------------------------------------  //
//   NEC/BENQ IR Code 32 bit (4 Byte)                                  //
//   Der Rahmen dauert 107,9ms oder 186 Perioden ( T=0,58ms )          //
//   Er besteht aus einem 'syn pulse' ( 15,5T high, 8T low ),          //
//   'Adress_high', 'Adress_low', 'Data' und 'inverted Data'.          //
//   --- Data "0" : 1T high, 1T low                                    //
//   --- Data "1" : 1T high, 3T low                                    //
// ------------------------------------------------------------------  //
#int_ext
void IR_isr() {
  cnt=get_timer1();
  lCode<<=1; l++;                                               // state
  if (cnt>3200) db=true;
  if (cnt>15000) { l=0; lCode=0; }
  if (l==32){                  // BENQ Fernbedienung: address_low = 0x0c
     if (IRAdr == 0x0c) { IRCode=(byte)lCode; new_IRCode=true; }
  }
  set_timer1(0);
}
// ------------------------------------------------------------------  //

